class AppMetrics:
    def __init__(self, name: str):
        # Initialize the AppMetrics object with the given name
        self.name: str = name
        self.metricType: int = 2
        self.current_count: int = 0
        self.peak_count: int = 0
        self.total_count: int = 0
        self.failure_count: int = 0
        self.success_count: int = 0
        self.success_peak_time: int = 0
        self.failure_peak_time: int = 0
        self.success_total_time: int = 0
        self.failure_total_time: int = 0

    # def createItem(self):
    #     # Create and return a new Item object associated with this AppMetrics instance
    #     i = Item(self)
    #     return i

    def increment_current_count(self):
        # Increment the current count by 1
        self.current_count += 1
        # print(f"incremented current_count: {self.current_count}")

    def decrement_current_count(self):
        # Decrement the current count by 1
        self.current_count -= 1
        # print(f"decremented current_count: {self.current_count}")

    def accumulate(self, item):
        # Accumulate metrics based on the provided item
        self.total_count += 1
        if self.current_count > self.peak_count:
            self.peak_count = self.current_count
        # Convert to nano sec
        delta = (item.stop_time - item.start_time) * 1000000
        if item.fail:
            # Update failure metrics
            self.failure_count += 1
            self.failure_total_time += delta
            if delta > self.failure_peak_time:
                self.failure_peak_time = delta
        else:
            # Update success metrics
            self.success_count += 1
            self.success_total_time += delta
            if delta > self.success_peak_time:
                self.success_peak_time = delta

    def reset(self):
        # Reset all metrics to their initial values
        # self.current_count = 0
        self.peak_count = 0
        self.total_count = 0
        self.failure_count = 0
        self.success_count = 0
        self.success_peak_time = 0
        self.failure_peak_time = 0
        self.success_total_time = 0
        self.failure_total_time = 0
