import time

from app_metrics import AppMetrics


class Item:
    def __init__(self, app_metrics: AppMetrics):
        # Initialize the Item object with the provided AppMetrics object
        self.app_metrics = app_metrics
        self.start_time = 0
        self.stop_time = 0
        self.fail: bool = False

    def start(self):
        # Start the item
        self.start_time = time.time() * 1000  # Get current time in millisec
        self.fail = False
        self.app_metrics.increment_current_count()

    def stop(self):
        # Stop the item
        self.stop_time = time.time() * 1000  # Get current time in milliseconds
        self.fail = False
        self.app_metrics.accumulate(self)
        self.app_metrics.decrement_current_count()

    def set_failed(self):
        # Mark the item as failed
        self.stop_time = time.time() * 1000  # Get current time in milliseconds
        self.fail = True
        self.app_metrics.accumulate(self)
        self.app_metrics.decrement_current_count()
